## rmlint 2.4.6

=== SConstruct ===
#!/usr/bin/env python
# encoding: utf-8

import os
import sys
import glob
import subprocess
import platform

import SCons.Conftest as tests

pkg_config = os.getenv('PKG_CONFIG') or 'pkg-config'

def read_version():
    with open('.version', 'r') as handle:
        version_string = handle.read()

    static_git_rev = None
    version_numbers, release_name = version_string.split(' ', 1)
    if '@' in release_name:
        release_name, static_git_rev = release_name.split('@', 1)
        static_git_rev.strip()

    major, minor, patch = [int(v) for v in version_numbers.split('.')]
    return major, minor, patch, release_name.strip(), static_git_rev


VERSION_MAJOR, VERSION_MINOR, VERSION_PATCH, VERSION_NAME, STATIC_GIT_REV = read_version()
Export('VERSION_MAJOR VERSION_MINOR VERSION_PATCH VERSION_NAME')

###########################################################################
#                                Utilities                                #
###########################################################################

def check_pkgconfig(context, version):
    context.Message('Checking for pkg-config... ')
    command = pkg_config + ' --atleast-pkgconfig-version=' + version
    ret = context.TryAction(command)[0]
    context.Result(ret)
    return ret


def check_pkg(context, name, varname, required=True):
    rc, text = 1, ''

    try:
        if GetOption('with_' + name.split()[0]) is False:
            context.Message('Explicitly disabling %s...' % name)
            rc = 0
    except AttributeError:
        pass

    if rc is not 0:
        context.Message('Checking for %s... ' % name)
        rc, text = context.TryAction('%s --exists \'%s\'' % (pkg_config, name))

    # 0 is defined as error by TryAction
    if rc is 0 and required:
        print('Error: ' + name + ' not found.')
        Exit(1)

    # Remember we have it:
    conf.env[varname] = rc
    context.Result(rc)
    return rc, text


def check_git_rev(context):
    context.Message('Checking for git revision... ')
    rev = STATIC_GIT_REV

    try:
        rev = subprocess.check_output('git log --pretty=format:"%h" -n 1', shell=True)
    except subprocess.CalledProcessError:
        print('Unable to find git revision.')
    except AttributeError:
        # Patch for some special sandbox permission problems.
        # See https://github.com/sahib/rmlint/issues/143#issuecomment-139929733
        print('Not allowed.')

    rev = rev or 'unknown'
    conf.env['gitrev'] = rev
    context.Result(rev)
    return rev


def check_libelf(context):
    rc = 1

    if GetOption('with_libelf') is False:
        rc = 0

    if rc and tests.CheckHeader(context, 'libelf.h', header="#include <stdlib.h>"):
        rc = 0

    if rc and tests.CheckLib(context, ['libelf']):
        rc = 0

    conf.env['HAVE_LIBELF'] = rc

    context.did_show_result = True
    context.Result(rc)
    return rc


def check_uname(context):
    rc = 1

    if rc and tests.CheckHeader(context, 'sys/utsname.h', header=""):
        rc = 0

    conf.env['HAVE_UNAME'] = rc

    context.did_show_result = True
    context.Result(rc)
    return rc


def check_gettext(context):
    rc = 1

    if GetOption('with_gettext') is False:
        rc = 0

    if rc and tests.CheckHeader(context, 'locale.h'):
        rc = 0

    conf.env['HAVE_LIBINTL'] = rc
    conf.env['HAVE_MSGFMT'] = int(WhereIs('msgfmt') is not None)
    conf.env['HAVE_GETTEXT'] = conf.env['HAVE_MSGFMT'] and conf.env['HAVE_LIBINTL']

    context.did_show_result = True
    context.Result(rc)
    return rc


def check_fiemap(context):
    rc = 1

    if GetOption('with_gettext') is False:
        rc = 0

    if rc and tests.CheckType(context, 'struct fiemap', header='#include <linux/fiemap.h>\n'):
        rc = 0

    conf.env['HAVE_FIEMAP'] = rc

    context.did_show_result = True
    context.Result(rc)
    return rc


def check_bigfiles(context):
    off_t_is_big_enough = True

    if tests.CheckTypeSize(context, 'off_t', header='#include <sys/types.h>\n') < 8:
        off_t_is_big_enough = False

    have_stat64 = True
    if tests.CheckFunc(
        context, 'stat64',
        header=
            '#include <sys/types.h>'
            '#include <sys/stat.h>'
            '#include <unistd.h>'

    ):
        have_stat64 = False

    rc = int(off_t_is_big_enough or have_stat64)
    conf.env['HAVE_BIG_OFF_T'] = int(off_t_is_big_enough)
    conf.env['HAVE_BIG_STAT'] = int(have_stat64)
    conf.env['HAVE_BIGFILES'] = rc

    context.did_show_result = True
    context.Result(rc)
    return rc


def check_blkid(context):
    rc = 1

    if GetOption('with_blkid') is False:
        rc = 0

    if rc is 1 and tests.CheckDeclaration(
        context,
        symbol='blkid_devno_to_wholedisk',
        includes='#include <blkid.h>\n'
    ):
        rc = 0

    conf.env['HAVE_BLKID'] = rc

    context.did_show_result = True
    context.Result(rc)
    return rc


def check_sys_block(context):
    rc = 1

    context.Message('Checking for existence of /sys/block... ')
    if not os.access('/sys/block', os.R_OK):
        rc = 0

    conf.env['HAVE_SYSBLOCK'] = rc

    context.Result(rc)
    return rc


def check_posix_fadvise(context):
    rc = 1

    if tests.CheckDeclaration(
        context, 'posix_fadvise',
        includes='#include <fcntl.h>'
    ):
        rc = 0

    conf.env['HAVE_POSIX_FADVISE'] = rc

    context.did_show_result = True
    context.Result(rc)
    return rc


def check_faccessat(context):
    # Seems to be missing in Mac OSX <= 10.9
    rc = 1

    if tests.CheckDeclaration(
        context, 'faccessat',
        includes='#include <unistd.h>'
    ):
        rc = 0

    if rc == 1 and tests.CheckDeclaration(
        context, 'AT_FDCWD',
        includes='#include <fcntl.h>'
    ):
        rc = 0

    conf.env['HAVE_FACCESSAT'] = rc

    context.did_show_result = True
    context.Result(rc)
    return rc


def check_xattr(context):
    rc = 1

    for func in ['getxattr', 'setxattr', 'removexattr']:
        if tests.CheckFunc(
            context, func,
            header=
                '#include <sys/types.h>'
                '#include <sys/xattr.h>'
        ):
            rc = 0
            break

    conf.env['HAVE_XATTR'] = rc

    context.did_show_result = True
    context.Result(rc)
    return rc


def check_sha512(context):
    rc = 1
    if tests.CheckDeclaration(context, 'G_CHECKSUM_SHA512', includes='#include <glib.h>\n'):
        rc = 0

    conf.env['HAVE_SHA512'] = rc

    context.did_show_result = True
    context.Result(rc)
    return rc


def check_c11(context):
    rc = 1

    context.Message('Checking for -std=c11 support...')
    try:
        cmd = 'echo "#if __STDC_VERSION__ < 201112L\n#error \"No C11 support!\"\n#endif" | {cc} -xc - -std=c11 -c'
        subprocess.check_call(
            cmd.format(cc=conf.env['CC']),
            shell=True
        )
    except subprocess.CalledProcessError:
        rc = 0  # Oops.

    conf.env['HAVE_C11'] = rc
    context.Result(rc)
    return rc


def check_btrfs_h(context):
    rc = 1
    if tests.CheckHeader(
        context, 'linux/btrfs.h',
        header='#include <stdlib.h>\n#include <sys/ioctl.h>'
    ):
        rc = 0

    conf.env['HAVE_BTRFS_H'] = rc
    context.did_show_result = True
    context.Result(rc)
    return rc


def check_linux_limits(context):
    rc = 1
    if tests.CheckHeader(context, 'linux/limits.h'):
        rc = 0

    conf.env['HAVE_LINUX_LIMITS'] = rc
    context.did_show_result = True
    context.Result(rc)
    return rc

def check_cygwin(context):
    rc = 0

    context.Message('Checking for cygwin environment...')
    try:
        uname = platform.uname()
        context.Message('/'.join(uname))
        rc = (uname[0].upper().startswith("CYGWIN"))
    except subprocess.CalledProcessError:
        rc = 0  # Oops.
        context.Message("platform.uname() failed")

    conf.env['IS_CYGWIN'] = rc
    context.Result(rc)
    return rc


def create_uninstall_target(env, path):
    env.Command("uninstall-" + path, path, [
        Delete("$SOURCE"),
    ])
    env.Alias("uninstall", "uninstall-" + path)


Export('create_uninstall_target')


def find_sphinx_binary():
    PATH = os.getenv('PATH')
    binaries = []
    for path in PATH.split(os.pathsep):
        binaries.extend(glob.glob(os.path.join(path, 'sphinx-build*')))

    def version_key(binary):
        splitted = binary.rsplit('-', 1)
        if len(splitted) < 3:
            return 0
        return float(splitted[-1])

    binaries = sorted(binaries, key=version_key, reverse=True)
    if binaries:
        print('Using sphinx-build binary: {}'.format(binaries[0]))
        return binaries[0]
    else:
        print('Unable to find sphinx binary in PATH')
        print('Will be unable to build manpage or html docs')


Export('find_sphinx_binary')

###########################################################################
#                                 Colors!                                 #
###########################################################################

if sys.stdout.isatty():
    COLORS = {
        'cyan': '\033[96m',
        'purple': '\033[95m',
        'blue': '\033[94m',
        'green': '\033[92m',
        'yellow': '\033[93m',
        'red': '\033[91m',
        'grey': '\x1b[30;1m',
        'end': '\033[0m'
    }
else:
    COLORS = {
        'cyan': '',
        'purple': '',
        'blue': '',
        'green': '',
        'yellow': '',
        'red': '',
        'grey': '',
        'end': ''
    }

# If the output is not a terminal, remove the COLORS
if not sys.stdout.isatty():
    for key, value in COLORS.iteritems():
        COLORS[key] = ''

# Configure the actual colors to our liking:
compile_source_message = '%sCompiling %s==> %s$SOURCE%s' % \
    (COLORS['blue'], COLORS['purple'], COLORS['yellow'], COLORS['end'])

compile_shared_source_message = '%sCompiling shared %s==> %s$SOURCE%s' % \
    (COLORS['blue'], COLORS['purple'], COLORS['yellow'], COLORS['end'])

link_program_message = '%sLinking Program %s==> %s$TARGET%s' % \
    (COLORS['red'], COLORS['purple'], COLORS['yellow'], COLORS['end'])

link_library_message = '%sLinking Static Library %s==> %s$TARGET%s' % \
    (COLORS['red'], COLORS['purple'], COLORS['yellow'], COLORS['end'])

ranlib_library_message = '%sRanlib Library %s==> %s$TARGET%s' % \
    (COLORS['red'], COLORS['purple'], COLORS['yellow'], COLORS['end'])

link_shared_library_message = '%sLinking Shared Library %s==> %s$TARGET%s' % \
    (COLORS['red'], COLORS['purple'], COLORS['yellow'], COLORS['end'])

###########################################################################
#                            Option Parsing                               #
###########################################################################

AddOption(
    '--prefix', default='/usr/local',
    dest='prefix', type='string', nargs=1,
    action='store', metavar='DIR', help='installation prefix'
)

AddOption(
    '--actual-prefix', default=None,
    dest='actual_prefix', type='string', nargs=1,
    action='store', metavar='DIR', help='where files will eventually land'
)

AddOption(
    '--libdir', default='lib',
    dest='libdir', type='string', nargs=1,
    action='store', metavar='DIR', help='libdir name (lib or lib64)'
)

for suffix in ['libelf', 'gettext', 'fiemap', 'blkid', 'json-glib', 'gui']:
    AddOption(
        '--without-' + suffix, action='store_const', default=False, const=False,
        dest='with_' + suffix
    )
    AddOption(
        '--with-' + suffix, action='store_const', default=True, const=True,
        dest='with_' + suffix
    )

AddOption(
    '--with-sse', action='store_const', default=False, const=False, dest='with_sse'
)

AddOption(
    '--without-sse', action='store_const', default=False, const=False, dest='with_sse'
)

# General Environment
options = dict(
    CXXCOMSTR=compile_source_message,
    CCCOMSTR=compile_source_message,
    SHCCCOMSTR=compile_shared_source_message,

=== debian/changelog ===
rmlint (2.4.6-2) unstable; urgency=medium

  * Fix missing dependencies in rmlint-gui package. (Closes: #855255)
  * Rename debian/docs to debian/rmlint.docs for consistency's sake.
  * Fix FTBFS for hurd-i386.
  * Exclude compiled schema from being packaged with rmlint-gui.
  * Fix formatting of unordered list in man page.
  * Fix HTML generated by privacy-breach-workaround.patch.

 -- Carlos Maddela <e7appew@gmail.com>  Fri, 17 Feb 2017 13:35:29 +1100

rmlint (2.4.6-1) unstable; urgency=medium

  * Initial upload to Debian. Thanks to Axel Beckert for getting
    it all started, and to Roger Shimizu for suggested improvements.
    (Closes: #845155)

 -- Carlos Maddela <e7appew@gmail.com>  Tue, 14 Feb 2017 23:11:30 +1100

=== debian/control ===
Source: rmlint
Section: utils
Priority: optional
Maintainer: Carlos Maddela <e7appew@gmail.com>
Build-Depends: debhelper (>= 10),
               dh-python,
               libblkid-dev,
               libelf-dev,
               libglib2.0-dev (>= 2.32),
               libjson-glib-dev,
               pkg-config (>= 0.15),
               python3,
               python3-nose,
               python3-sphinx,
               python3-sphinx-bootstrap-theme (>= 0.4.3),
               scons
Standards-Version: 3.9.8
Homepage: https://rmlint.readthedocs.io/
Vcs-Git: https://anonscm.debian.org/git/collab-maint/rmlint.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/rmlint.git

Package: rmlint
Architecture: any
Multi-Arch: allowed
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: rmlint-gui (= ${source:Version})
Suggests: rmlint-doc (= ${source:Version})
Description: Extremely fast tool to remove filesystem lint
 rmlint finds space waste and other broken things on your filesystem
 and offers to remove them.
 .
 It is able to find:
  * Duplicate files & directories.
  * Non-stripped binaries.
  * Broken symlinks.
  * Empty files.
  * Recursive empty directories.
  * Files with broken user or group ID.
 .
 Key Features:
  * Extremely fast.
  * Flexible and easy command-line options.
  * Choice of several hashes for hash-based duplicate detection.
  * Option for exact byte-by-byte comparison (only slightly slower).
  * Numerous output options.
  * Option to store time  of last run; next time will only scan new files.
  * Many options for original selection/prioritisation.
  * Can handle very large file sets (millions of files).
  * Colourful progress bar.

Package: rmlint-gui
Architecture: all
Multi-Arch: foreign
Depends: gir1.2-gtksource-3.0,
         gir1.2-polkit-1.0,
         gir1.2-rsvg-2.0,
         python3-cairo,
         python3-gi,
         rmlint:any (>= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends}
Recommends: python3-colorlog
Description: GTK+ frontend to rmlint
 rmlint-gui (a.k.a. Shredder) is a graphical user interface to rmlint
 using GTK+. It uses rmlint to find space waste and other broken things
 on your filesystem and offers to remove them.
 .
 It is able to find:
  * Duplicate files & directories.
  * Non-stripped binaries.
  * Broken symlinks.
  * Empty files.
  * Recursive empty directories.
  * Files with broken user or group ID.
 .
 Key Features:
  * Extremely fast.
  * Flexible and easy command-line options.
  * Choice of several hashes for hash-based duplicate detection.
  * Option for exact byte-by-byte comparison (only slightly slower).
  * Numerous output options.
  * Option to store time  of last run; next time will only scan new files.
  * Many options for original selection/prioritisation.
  * Can handle very large file sets (millions of files).

Package: rmlint-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-bootstrap,
         libjs-bootswatch,
         libjs-mathjax,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Description: HTML documentation for rmlint
 rmlint finds space waste and other broken things on your filesystem
 and offers to remove them.
 .
 It is able to find:
  * Duplicate files & directories.
  * Non-stripped binaries.
  * Broken symlinks.
  * Empty files.
  * Recursive empty directories.
  * Files with broken user or group ID.
 .
 Key Features:
  * Extremely fast.
  * Flexible and easy command-line options.
  * Choice of several hashes for hash-based duplicate detection.
  * Option for exact byte-by-byte comparison (only slightly slower).
  * Numerous output options.
  * Option to store time  of last run; next time will only scan new files.
  * Many options for original selection/prioritisation.
  * Can handle very large file sets (millions of files).
  * Colourful progress bar.
 .
 This package provides documentation in HTML for rmlint.

## rmlint 2.6.1

=== SConstruct ===
--- 
+++ 
@@ -7,7 +7,9 @@
 import subprocess
 import platform
 
+import SCons
 import SCons.Conftest as tests
+from SCons.Script.SConscript import SConsEnvironment
 
 pkg_config = os.getenv('PKG_CONFIG') or 'pkg-config'
 
@@ -82,6 +84,17 @@
     conf.env['gitrev'] = rev
     context.Result(rev)
     return rev
+
+
+def check_sysmacro_h(context):
+    rc = 1
+    if rc and tests.CheckHeader(context, 'sys/sysmacros.h'):
+        rc = 0
+
+    conf.env['HAVE_SYSMACROS_H'] = rc
+    context.did_show_result = True
+    context.Result(rc)
+    return rc
 
 
 def check_libelf(context):
@@ -457,15 +470,3 @@
     )
 
 AddOption(
-    '--with-sse', action='store_const', default=False, const=False, dest='with_sse'
-)
-
-AddOption(
-    '--without-sse', action='store_const', default=False, const=False, dest='with_sse'
-)
-
-# General Environment
-options = dict(
-    CXXCOMSTR=compile_source_message,
-    CCCOMSTR=compile_source_message,
-    SHCCCOMSTR=compile_shared_source_message,

=== debian/changelog ===
rmlint (2.6.1-1) unstable; urgency=medium

  * New upstream version [2.6.1].
  * Rebase patch queue and drop changes already applied upstream.
  * Indicate compliance with latest standards version [4.0.0].
  * Make 'parameterized' module available to 'nose' tests.
  * Simplify (and hopefully make adaptable to future changes in host
    names and version numbers) the sed rules for patching HTML docs.
  * Fix man page typos.
  * Avoid calling dpkg-parsechangelog directly from debian/rules.
  * Fix new privacy breach issues by disabling the asciinema demo
    and the use of web fonts.
  * Add package test to prevent privacy breach issues in HTML docs.

 -- Carlos Maddela <e7appew@gmail.com>  Mon, 31 Jul 2017 09:44:43 +1000

=== debian/control ===
--- 
+++ 
@@ -10,14 +10,15 @@
                libjson-glib-dev,
                pkg-config (>= 0.15),
                python3,
-               python3-nose,
+               python3-nose-parameterized,
                python3-sphinx,
                python3-sphinx-bootstrap-theme (>= 0.4.3),
                scons
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: https://rmlint.readthedocs.io/
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/rmlint.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/rmlint.git
+Testsuite: autopkgtest
 
 Package: rmlint
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# The following workaround is necessary for hardening, since
# the project's SConstruct file doesn't make use of CPPFLAGS.
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
export DEB_CFLAGS_MAINT_APPEND = $(CPPFLAGS) \
	$(if $(filter $(DEB_HOST_ARCH_BITS),32),-D_FILE_OFFSET_BITS=64)

# Ensure that we use the python3 version of sphinx.
export PATH := /usr/share/sphinx/scripts/python3:$(PATH)

# Prevent sphinx from trying to automatically import themes.
export http_proxy := http://127.0.0.1:9/

DEB_BUILD_ROOT := $(CURDIR)/debian/tmp
DBO := $(DEB_BUILD_OPTIONS) $(DEB_BUILD_MAINT_OPTIONS)
NUM_JOBS := $(lastword $(patsubst parallel=%,%,$(filter parallel=%,$(DBO))))
COMMON_SCONS_OPTS := \
	--prefix=$(DEB_BUILD_ROOT)/usr --actual-prefix=/usr --without-gui \
	$(if $(NUM_JOBS),-j$(NUM_JOBS)) \
	$(if $(filter $(DH_VERBOSE),1),VERBOSE=1) \
	$(if $(findstring debug,$(DBO)),DEBUG=1)

# Fudge build date using SOURCE_DATE_EPOCH for build reproducibility.
include /usr/share/dpkg/pkg-info.mk
DATE := @$(SOURCE_DATE_EPOCH)
export BUILD_DATE := $(shell date -u -d '$(DATE)' +'%b %d %Y')
export BUILD_TIME := $(shell date -u -d '$(DATE)' +%T)

# Sensible defaults for test suite.
export RM_TS_PRINT_CMD = 0
export RM_TS_PEDANTIC = 0

# Set locale so that python3 nose tests run with UTF-8 support
# in all build environments.
export LC_ALL = C.UTF-8

%:
	dh $@ --with python3,sphinxdoc

override_dh_auto_clean:
	scons -c $(COMMON_SCONS_OPTS) install

override_dh_auto_configure-arch:
	scons $(COMMON_SCONS_OPTS) config

override_dh_auto_build-arch:
	scons $(COMMON_SCONS_OPTS)

override_dh_auto_install-arch:
	scons $(COMMON_SCONS_OPTS) install

override_dh_auto_configure-indep:
	@echo "*** No-op. ***"

override_dh_auto_build-indep:
	scons $(COMMON_SCONS_OPTS) docs
	rm -rf docs/_build/html/_static/bootstrap-?.?.? docs/_build/html/_static/bootswatch-?.?.?
	sed -i \
		-e 's@http[s]\?://.\+/mathjax/[^/]\+/[Mm]ath[Jj]ax.js@file:///usr/share/javascript/mathjax/MathJax.js@g' \
		-e 's@\(bootstrap\|bootswatch\)-[[:digit:]]\(\.[[:digit:]]\)\{2\}@\1@g' \
		docs/_build/html/*.html

override_dh_auto_install-indep:
	cd gui && \
	python3 setup.py install --prefix=$(DEB_BUILD_ROOT)/usr --install-layout=deb

override_dh_install:
	dh_install -prmlint-gui -X.compiled -X.gz -X.mo
	dh_install --remaining-packages

override_dh_installdocs:
	dh_installdocs -prmlint-doc -X.inv
	dh_installdocs --remaining-packages

override_dh_sphinxdoc:
	dh_sphinxdoc -prmlint-doc -Xbootstrap -Xbootswatch -Xjquery-
	dh_sphinxdoc --remaining-packages

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DBO)))
	# Ignore result of the test suite for now
	-scons $(COMMON_SCONS_OPTS) test
else
	@echo "*** Tests disabled via DEB_BUILD(_MAINT)?_OPTIONS. ***"
endif

## rmlint 2.8.0

=== SConstruct ===
--- 
+++ 
@@ -11,7 +11,7 @@
 import SCons.Conftest as tests
 from SCons.Script.SConscript import SConsEnvironment
 
-pkg_config = os.getenv('PKG_CONFIG') or 'pkg-config'
+pkg_config = os.getenv('PKG_CONFIG', 'pkg-config')
 
 def read_version():
     with open('.version', 'r') as handle:
@@ -33,6 +33,28 @@
 ###########################################################################
 #                                Utilities                                #
 ###########################################################################
+
+def check_gcc_version(context):
+    context.Message('Checking for GCC version... ')
+
+    try:
+        v = subprocess.check_output("printf '%s\n' __GNUC__ | gcc -E -P -", shell=True)
+        try:
+            v = int(v)
+            context.Result(str(v))
+        except ValueError:
+            print('Expected a number, but got: ' + v)
+            v = 0
+    except subprocess.CalledProcessError:
+        print('Unable to find GCC version.')
+        v = 0
+    except AttributeError:
+        print('Not allowed.')
+        v = 0
+
+    conf.env['__GNUC__'] = v
+    return v
+
 
 def check_pkgconfig(context, version):
     context.Message('Checking for pkg-config... ')
@@ -325,6 +347,15 @@
     context.Result(rc)
     return rc
 
+def check_linux_fs_h(context):
+    rc = 1
+    if tests.CheckHeader(context, 'linux/fs.h'):
+        rc = 0
+
+    conf.env['HAVE_LINUX_FS_H'] = rc
+    context.did_show_result = True
+    context.Result(rc)
+    return rc
 
 def check_linux_limits(context):
     rc = 1
@@ -349,6 +380,30 @@
         context.Message("platform.uname() failed")
 
     conf.env['IS_CYGWIN'] = rc
+    context.Result(rc)
+    return rc
+
+def check_mm_crc32_u64(context):
+
+    rc = 0 if tests.CheckDeclaration(
+            context,
+            symbol='_mm_crc32_u64',
+            includes='#include <nmmintrin.h>\n'
+            ) else 1
+
+    conf.env['HAVE_MM_CRC32_U64'] = rc
+    context.did_show_result = True
+    context.Result(rc)
+    return rc
+
+def check_builtin_cpu_supports(context):
+    rc = 0 if tests.CheckDeclaration(
+            context,
+            symbol='__builtin_cpu_supports'
+            ) else 1
+
+    conf.env['HAVE_BUILTIN_CPU_SUPPORTS'] = rc
+    context.did_show_result = True
     context.Result(rc)
     return rc
 
@@ -415,7 +470,7 @@
 
 # If the output is not a terminal, remove the COLORS
 if not sys.stdout.isatty():
-    for key, value in COLORS.iteritems():
+    for key, value in COLORS.items():
         COLORS[key] = ''
 
 # Configure the actual colors to our liking:
@@ -431,42 +486,3 @@
 link_library_message = '%sLinking Static Library %s==> %s$TARGET%s' % \
     (COLORS['red'], COLORS['purple'], COLORS['yellow'], COLORS['end'])
 
-ranlib_library_message = '%sRanlib Library %s==> %s$TARGET%s' % \
-    (COLORS['red'], COLORS['purple'], COLORS['yellow'], COLORS['end'])
-
-link_shared_library_message = '%sLinking Shared Library %s==> %s$TARGET%s' % \
-    (COLORS['red'], COLORS['purple'], COLORS['yellow'], COLORS['end'])
-
-###########################################################################
-#                            Option Parsing                               #
-###########################################################################
-
-AddOption(
-    '--prefix', default='/usr/local',
-    dest='prefix', type='string', nargs=1,
-    action='store', metavar='DIR', help='installation prefix'
-)
-
-AddOption(
-    '--actual-prefix', default=None,
-    dest='actual_prefix', type='string', nargs=1,
-    action='store', metavar='DIR', help='where files will eventually land'
-)
-
-AddOption(
-    '--libdir', default='lib',
-    dest='libdir', type='string', nargs=1,
-    action='store', metavar='DIR', help='libdir name (lib or lib64)'
-)
-
-for suffix in ['libelf', 'gettext', 'fiemap', 'blkid', 'json-glib', 'gui']:
-    AddOption(
-        '--without-' + suffix, action='store_const', default=False, const=False,
-        dest='with_' + suffix
-    )
-    AddOption(
-        '--with-' + suffix, action='store_const', default=True, const=True,
-        dest='with_' + suffix
-    )
-
-AddOption(

=== gui/Makefile ===
resources:
	@glib-compile-resources shredder/resources/shredder.gresource.xml --sourcedir shredder/resources

schema:
	@mkdir -p ~/.glib-schemas
	@cp shredder/resources/org.gnome.Shredder.gschema.xml ~/.glib-schemas
	@glib-compile-schemas ~/.glib-schemas

run: resources schema
	@GSETTINGS_SCHEMA_DIR=~/.glib-schemas/ python3 shredder/__main__.py

all: run

=== debian/changelog ===
rmlint (2.8.0-3) unstable; urgency=medium

  * Re-enable SSE4.2 optimisations without causing SIGILL faults.
  * Fix changelog details in debian/upstream/metadata.
  * Update debian/gbp.conf to conform with DEP14 conventions.
  * Suppress maintainer-script-supports-ancient-package-version
    lintian warnings.
  * Update sed rule to substitute local copy of MathJax script.

 -- Carlos Maddela <e7appew@gmail.com>  Mon, 28 Jan 2019 11:31:11 +1100

rmlint (2.8.0-2) unstable; urgency=medium

  * Fix debian/tests/privacy-breach test to account for change
    in document location.
  * Allow debhelper to handle stripping of binaries.
  * Build with Debhelper compat level 12.
  * Remove unnecessary build dependencies for nocheck build profile.
  * Fix builds for hurd, kfreebsd and sparc64 by relaxing build dependency
    on python3-psutil for those architectures. It currently doesn't support
    those architectures and is only required for running tests anyway.
  * Fix nosetests search.
  * Fix program termination by SIGILL signal, by removing sse4 instructions.
  * Update debian/clean list.

 -- Carlos Maddela <e7appew@gmail.com>  Thu, 10 Jan 2019 12:15:02 +1100

rmlint (2.8.0-1) unstable; urgency=medium

  * New upstream release [2.8.0].
  * debian/patches/*:
    - Rebase patches.
    - Drop manpage-typos.patch already applied upstream.
    - Add doco-typos.patch to fix typos in documentation.
    - Drop parameterized-workaround.patch, which is no longer
      necessary.
  * Add dependency on packaged version of Vollkorn desktop font,
    so that its use in HTML docs may be restored.  Thanks to
    Adam Borowski for suggestion.
  * Add debian/gbp.conf.
  * debian/control:
    - Update Vcs-* to salsa.debian.org.
    - Remove unnecessary Testsuite field.
    - Set "Rules-Requires-Root: no".
    - Indicate compliance with Debian Policy 4.3.0.
    - Update build dependencies.
  * Update lintian override to debian-watch-does-not-check-gpg-signature.
  * Add machine-readable upstream metadata.
  * debian/rules:
    - Simplify LFS build rules.
  * Update debian/copyright.
  * Build with Debhelper compat level 11.
  * Link instances of jquery to packaged version.
  * Add maintainer scripts for upgrading to and downgrading from
    this version of rmlint-doc, since it has some symlink changes.

 -- Carlos Maddela <e7appew@gmail.com>  Mon, 31 Dec 2018 23:52:54 +1100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: utils
 Priority: optional
 Maintainer: Carlos Maddela <e7appew@gmail.com>
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 12),
                dh-python,
                libblkid-dev,
                libelf-dev,
@@ -10,15 +10,17 @@
                libjson-glib-dev,
                pkg-config (>= 0.15),
                python3,
-               python3-nose-parameterized,
+               python3-nose (>= 1.3.7) <!nocheck>,
+               python3-parameterized (>= 0.6.1) <!nocheck>,
+               python3-psutil (>= 5.2.2) [!hurd-any !kfreebsd-any !sparc64] <!nocheck>,
                python3-sphinx,
                python3-sphinx-bootstrap-theme (>= 0.4.3),
                scons
-Standards-Version: 4.0.0
+Standards-Version: 4.3.0
 Homepage: https://rmlint.readthedocs.io/
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/rmlint.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/rmlint.git
-Testsuite: autopkgtest
+Vcs-Git: https://salsa.debian.org/debian/rmlint.git
+Vcs-Browser: https://salsa.debian.org/debian/rmlint
+Rules-Requires-Root: no
 
 Package: rmlint
 Architecture: any
@@ -88,11 +90,14 @@
 Section: doc
 Architecture: all
 Multi-Arch: foreign
-Depends: libjs-bootstrap,
+Depends: fonts-vollkorn,
+         libjs-bootstrap,
          libjs-bootswatch,
+         libjs-jquery,
          libjs-mathjax,
          ${misc:Depends},
          ${sphinxdoc:Depends}
+Pre-Depends: dpkg (>= 1.17.14)
 Built-Using: ${sphinxdoc:Built-Using}
 Description: HTML documentation for rmlint
  rmlint finds space waste and other broken things on your filesystem

=== debian/rules ===
--- 
+++ 
@@ -2,14 +2,13 @@
 
 export DH_VERBOSE = 1
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs
 
 # The following workaround is necessary for hardening, since
 # the project's SConstruct file doesn't make use of CPPFLAGS.
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
-export DEB_CFLAGS_MAINT_APPEND = $(CPPFLAGS) \
-	$(if $(filter $(DEB_HOST_ARCH_BITS),32),-D_FILE_OFFSET_BITS=64)
+export DEB_CFLAGS_MAINT_APPEND = $(CPPFLAGS)
 
 # Ensure that we use the python3 version of sphinx.
 export PATH := /usr/share/sphinx/scripts/python3:$(PATH)
@@ -24,7 +23,8 @@
 	--prefix=$(DEB_BUILD_ROOT)/usr --actual-prefix=/usr --without-gui \
 	$(if $(NUM_JOBS),-j$(NUM_JOBS)) \
 	$(if $(filter $(DH_VERBOSE),1),VERBOSE=1) \
-	$(if $(findstring debug,$(DBO)),DEBUG=1)
+	$(if $(findstring debug,$(DBO)),DEBUG=1) \
+	SYMBOLS=1
 
 # Fudge build date using SOURCE_DATE_EPOCH for build reproducibility.
 include /usr/share/dpkg/pkg-info.mk
@@ -60,10 +60,13 @@
 
 override_dh_auto_build-indep:
 	scons $(COMMON_SCONS_OPTS) docs
-	rm -rf docs/_build/html/_static/bootstrap-?.?.? docs/_build/html/_static/bootswatch-?.?.?
+	bash -O extglob \
+		-c "rm -rf docs/_build/html/_static/{bootstrap,bootswatch}-+([[:digit:]]).+([[:digit:]]).+([[:digit:]]) \
+		docs/_build/html/_static/js/jquery-+([[:digit:]]).+([[:digit:]]).+([[:digit:]]).min.js"
 	sed -i \
-		-e 's@http[s]\?://.\+/mathjax/[^/]\+/[Mm]ath[Jj]ax.js@file:///usr/share/javascript/mathjax/MathJax.js@g' \
-		-e 's@\(bootstrap\|bootswatch\)-[[:digit:]]\(\.[[:digit:]]\)\{2\}@\1@g' \
+		-e 's@http[s]\?://.\+/mathjax/[^/]\+/\([Mm]ath[Jj]ax\|latest\)\.js@file:///usr/share/javascript/mathjax/MathJax.js@g' \
+		-e 's@\(_static/\(bootstrap\|bootswatch\)\)-[[:digit:]]\+\(\.[[:digit:]]\+\)\{2\}@\1@g' \
+		-e 's@\(_static/js/jquery\)-[[:digit:]]\+\(\.[[:digit:]]\+\)\{2\}\(\.min\.js\)@\1\3@g' \
 		docs/_build/html/*.html
 
 override_dh_auto_install-indep:
@@ -79,7 +82,7 @@
 	dh_installdocs --remaining-packages
 
 override_dh_sphinxdoc:
-	dh_sphinxdoc -prmlint-doc -Xbootstrap -Xbootswatch -Xjquery-
+	dh_sphinxdoc -prmlint-doc -Xbootstrap -Xbootswatch -Xjquery.min.js
 	dh_sphinxdoc --remaining-packages
 
 override_dh_auto_test:

## rmlint 2.9.0

=== SConstruct ===
--- 
+++ 
@@ -287,7 +287,7 @@
 def check_xattr(context):
     rc = 1
 
-    for func in ['getxattr', 'setxattr', 'removexattr']:
+    for func in ['getxattr', 'setxattr', 'removexattr', 'listxattr']:
         if tests.CheckFunc(
             context, func,
             header=
@@ -298,6 +298,27 @@
             break
 
     conf.env['HAVE_XATTR'] = rc
+
+    context.did_show_result = True
+    context.Result(rc)
+    return rc
+
+
+
+def check_lxattr(context):
+    rc = 1
+
+    for func in ['lgetxattr', 'lsetxattr', 'lremovexattr', 'llistxattr']:
+        if tests.CheckFunc(
+            context, func,
+            header=
+                '#include <sys/types.h>'
+                '#include <sys/xattr.h>'
+        ):
+            rc = 0
+            break
+
+    conf.env['HAVE_LXATTR'] = rc
 
     context.did_show_result = True
     context.Result(rc)
@@ -477,12 +498,3 @@
 compile_source_message = '%sCompiling %s==> %s$SOURCE%s' % \
     (COLORS['blue'], COLORS['purple'], COLORS['yellow'], COLORS['end'])
 
-compile_shared_source_message = '%sCompiling shared %s==> %s$SOURCE%s' % \
-    (COLORS['blue'], COLORS['purple'], COLORS['yellow'], COLORS['end'])
-
-link_program_message = '%sLinking Program %s==> %s$TARGET%s' % \
-    (COLORS['red'], COLORS['purple'], COLORS['yellow'], COLORS['end'])
-
-link_library_message = '%sLinking Static Library %s==> %s$TARGET%s' % \
-    (COLORS['red'], COLORS['purple'], COLORS['yellow'], COLORS['end'])
-

=== gui/Makefile ===
--- 
+++ 
@@ -7,6 +7,6 @@
 	@glib-compile-schemas ~/.glib-schemas
 
 run: resources schema
-	@GSETTINGS_SCHEMA_DIR=~/.glib-schemas/ python3 shredder/__main__.py
+	@GSETTINGS_SCHEMA_DIR=~/.glib-schemas/ python3 -c "import shredder; shredder.run_gui()"
 
 all: run

=== debian/changelog ===
rmlint (2.9.0-2.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix data loss caused by faulty check in generated scripts (Closes: #977410)
    - Use upstream patch

 -- Timo Röhling <timo@gaussglocke.de>  Thu, 15 Apr 2021 23:03:37 +0200

rmlint (2.9.0-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS for cannot remove directory. (Closes: #975205)
    - Mention explicitly the file and directory to be cleaned.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 01 Dec 2020 20:37:43 +0000

rmlint (2.9.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix ftbfs with GCC-10. (Closes: #957764)
    - Use upstream patch, thanks to Reiner Herrmann.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 20 Aug 2020 20:43:54 +0100

rmlint (2.9.0-2) unstable; urgency=medium

  * Replace glib-2_62.patch with upstream implementation, which
    provides a fallback and hopefully will allow an ia64 build.

 -- Carlos Maddela <e7appew@gmail.com>  Wed, 01 Jan 2020 09:27:25 +1100

rmlint (2.9.0-1) unstable; urgency=medium

  * New upstream release [2.9.0]. (Closes: #928521)
  * Fix incorrect use of findstring function in debian/rules.
  * debian/patches/*:
    - Rebase drops patches already applied upstream: doco-typos.patch,
      fix-nosetests-search.patch and fix-pre-sse4.2.patch.
    - Update reproducible-build.patch to be Python version-agnostic
      so that package may be built with scons 3.1.2-1. (Closes: #947580)
    - Add xattr-fixes.patch cherry-picked from upstream
      which may resolve possible build failures in kfreebsd.
    - Add python3.8.patch to fix syntax warnings and missing metadata
      generated in egg-info.
    - Add glib-2_62.patch to remove deprecated API calls.
  * Drop use of debian/compat file.
  * Drop debian/rmlint-doc.lintian-overrides.
  * Update debian/clean.
  * Indicate compliance with Debian Policy 4.4.1 (no changes required).
  * Fix missing rmlint-gui dependency on python3-gi-cairo
    so that graphics are correctly displayed.
    Thanks to Andres for report. (Closes: #947615)

 -- Carlos Maddela <e7appew@gmail.com>  Tue, 31 Dec 2019 13:22:33 +1100

=== debian/rules ===
--- 
+++ 
@@ -23,7 +23,7 @@
 	--prefix=$(DEB_BUILD_ROOT)/usr --actual-prefix=/usr --without-gui \
 	$(if $(NUM_JOBS),-j$(NUM_JOBS)) \
 	$(if $(filter $(DH_VERBOSE),1),VERBOSE=1) \
-	$(if $(findstring debug,$(DBO)),DEBUG=1) \
+	$(if $(filter debug,$(DBO)),DEBUG=1) \
 	SYMBOLS=1
 
 # Fudge build date using SOURCE_DATE_EPOCH for build reproducibility.
@@ -86,7 +86,7 @@
 	dh_sphinxdoc --remaining-packages
 
 override_dh_auto_test:
-ifeq (,$(findstring nocheck,$(DBO)))
+ifeq (,$(filter nocheck,$(DBO)))
 	# Ignore result of the test suite for now
 	-scons $(COMMON_SCONS_OPTS) test
 else

=== debian/watch ===
version=4

opts="pagemangle=s%\"tarball_url\"[^\"]+\"[^\"]+/(v\d[\d.]*)\"%<a href=\"https://github.com/sahib/@PACKAGE@/archive/$1.tar.gz\">$1</a>%g, \
      filenamemangle=s%(?:.*?/)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%, \
      pgpmode=none" \
   https://api.github.com/repos/sahib/@PACKAGE@/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## rmlint 2.10.2

=== SConstruct ===
--- 
+++ 
@@ -74,12 +74,12 @@
     except AttributeError:
         pass
 
-    if rc is not 0:
+    if rc != 0:
         context.Message('Checking for %s... ' % name)
         rc, text = context.TryAction('%s --exists \'%s\'' % (pkg_config, name))
 
     # 0 is defined as error by TryAction
-    if rc is 0 and required:
+    if rc == 0 and required:
         print('Error: ' + name + ' not found.')
         Exit(1)
 
@@ -102,6 +102,9 @@
         # See https://github.com/sahib/rmlint/issues/143#issuecomment-139929733
         print('Not allowed.')
 
+    if hasattr(rev, 'decode'):
+       rev = rev.decode('ascii')
+
     rev = rev or 'unknown'
     conf.env['gitrev'] = rev
     context.Result(rev)
@@ -172,7 +175,7 @@
 def check_fiemap(context):
     rc = 1
 
-    if GetOption('with_gettext') is False:
+    if GetOption('with_fiemap') is False:
         rc = 0
 
     if rc and tests.CheckType(context, 'struct fiemap', header='#include <linux/fiemap.h>\n'):
@@ -218,7 +221,7 @@
     if GetOption('with_blkid') is False:
         rc = 0
 
-    if rc is 1 and tests.CheckDeclaration(
+    if rc == 1 and tests.CheckDeclaration(
         context,
         symbol='blkid_devno_to_wholedisk',
         includes='#include <blkid.h>\n'
@@ -255,29 +258,6 @@
         rc = 0
 
     conf.env['HAVE_POSIX_FADVISE'] = rc
-
-    context.did_show_result = True
-    context.Result(rc)
-    return rc
-
-
-def check_faccessat(context):
-    # Seems to be missing in Mac OSX <= 10.9
-    rc = 1
-
-    if tests.CheckDeclaration(
-        context, 'faccessat',
-        includes='#include <unistd.h>'
-    ):
-        rc = 0
-
-    if rc == 1 and tests.CheckDeclaration(
-        context, 'AT_FDCWD',
-        includes='#include <fcntl.h>'
-    ):
-        rc = 0
-
-    conf.env['HAVE_FACCESSAT'] = rc
 
     context.did_show_result = True
     context.Result(rc)
@@ -498,3 +478,10 @@
 compile_source_message = '%sCompiling %s==> %s$SOURCE%s' % \
     (COLORS['blue'], COLORS['purple'], COLORS['yellow'], COLORS['end'])
 
+compile_shared_source_message = '%sCompiling shared %s==> %s$SOURCE%s' % \
+    (COLORS['blue'], COLORS['purple'], COLORS['yellow'], COLORS['end'])
+
+link_program_message = '%sLinking Program %s==> %s$TARGET%s' % \
+    (COLORS['red'], COLORS['purple'], COLORS['yellow'], COLORS['end'])
+
+link_library_message = '%sLinking Static Library %s==> %s$TARGET%s' % \

=== debian/changelog ===
rmlint (2.10.2-0ubuntu1) oracular; urgency=medium

  * New upstream release (LP: #2039957)
  * d/rules: exclude jquery-fix.js from dh_sphinxdoc -prmlint-doc call
  * Drop patches applied upstream and refresh remaining patches
  * Build-depend on python3-xattr for new unit tests
  * Replace obsolete pkg-config by pkgconf
  * scons: add missing newline for included headers and check *xattr functions
    with correct arguments (Closes: #1065947, LP: #2066970)

 -- Benjamin Drung <bdrung@ubuntu.com>  Tue, 28 May 2024 11:20:05 +0200

rmlint (2.9.0-2.5) unstable; urgency=high

  * Non-maintainer upload.
  * Add upstream fix for GUI startup failure with recent python3.11.
    (Closes: #1040940)

 -- Adrian Bunk <bunk@debian.org>  Sat, 05 Aug 2023 17:16:05 +0300

rmlint (2.9.0-2.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix error in other packages caused by invalid python package version
    number (cherry-picking upstream patch; closes: #1040179)

 -- Julian Gilbey <jdg@debian.org>  Wed, 05 Jul 2023 09:31:46 +0100

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,24 @@
 Source: rmlint
 Section: utils
 Priority: optional
-Maintainer: Carlos Maddela <e7appew@gmail.com>
-Build-Depends: debhelper (>= 12),
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Carlos Maddela <e7appew@gmail.com>
+Build-Depends: debhelper-compat (= 12),
                dh-python,
                libblkid-dev,
                libelf-dev,
                libglib2.0-dev (>= 2.32),
                libjson-glib-dev,
-               pkg-config (>= 0.15),
+               pkgconf,
                python3,
                python3-nose (>= 1.3.7) <!nocheck>,
                python3-parameterized (>= 0.6.1) <!nocheck>,
                python3-psutil (>= 5.2.2) [!hurd-any !kfreebsd-any !sparc64] <!nocheck>,
                python3-sphinx,
                python3-sphinx-bootstrap-theme (>= 0.4.3),
-               scons
-Standards-Version: 4.3.0
+               python3-xattr,
+               scons (>= 4.5.2+dfsg-1ubuntu1~)
+Standards-Version: 4.4.1
 Homepage: https://rmlint.readthedocs.io/
 Vcs-Git: https://salsa.debian.org/debian/rmlint.git
 Vcs-Browser: https://salsa.debian.org/debian/rmlint
@@ -57,8 +59,7 @@
 Depends: gir1.2-gtksource-3.0,
          gir1.2-polkit-1.0,
          gir1.2-rsvg-2.0,
-         python3-cairo,
-         python3-gi,
+         python3-gi-cairo,
          rmlint:any (>= ${binary:Version}),
          ${misc:Depends},
          ${python3:Depends}

=== debian/rules ===
--- 
+++ 
@@ -82,7 +82,7 @@
 	dh_installdocs --remaining-packages
 
 override_dh_sphinxdoc:
-	dh_sphinxdoc -prmlint-doc -Xbootstrap -Xbootswatch -Xjquery.min.js
+	dh_sphinxdoc -prmlint-doc -Xbootstrap -Xbootswatch -Xjquery.min.js -Xjquery-fix.js
 	dh_sphinxdoc --remaining-packages
 
 override_dh_auto_test:
